import axios from 'axios';
import { API_URL } from '@/shared/api/urls';
import { resultify } from '@/shared/lib/resultify';
import { CBDCAxiosError } from '@/shared/@types/error';
import { CodesCacheRefreshResponse } from '../model/types';
import { 
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';

export const codesCacheRefresh = () => {
  return resultify(
    axios.post<CodesCacheRefreshResponse>(API_URL.codesCacheRefresh()),
  );
};

export const useCodesCacheRefreshMutation = (options?: UseMutationOptions<CodesCacheRefreshResponse, CBDCAxiosError>) => {
  const mutation = useMutation<CodesCacheRefreshResponse, CBDCAxiosError>({
    ...options,
    mutationFn: () => codesCacheRefresh(),
  });

  return {
    ...mutation,
  };
};
